# web-components by TotallyInformation

[![](https://data.jsdelivr.com/v1/package/gh/totallyinformation/web-components/badge)](https://www.jsdelivr.com/package/gh/TotallyInformation/web-components)

A repository of simple W3C Web Components. These may have extra capabilities for use with UIBUILDER for Node-RED but all work independently as well.

Additional documentation is available in the docs folder which is also exposed as a website at https://wc.totallyinformation.net/.

### Demos & Documentation

To see the web components in action, go to [`https://wc.totallyinformation.net`](https://wc.totallyinformation.net).

Documentation is available on the same website. You can also view the documentation in the `docs/` folder of this repository.

Alternatively, there is a built-in Node.js mini web server. Running the npm script `npm run tests` will start the server on port `8788`. Opening `http://127.0.0.1:8788` in your browser will give a list of all available demos and links to documentation and source code. Note that the mini-server has to download the Cloudflare `wrangler` server, you will be asked if you wish to continue.

## Components

Please see the [documentation](docs) for details of each component. Online documentation is available at [`https://wc.totallyinformation.net/docs`](https://wc.totallyinformation.net/docs).

## Development and building

Please see the [development documentation](docs/dev.md) for details on how to develop and build the components. [Online](https://wc.totallyinformation.net/docs/#/dev).

## Discussions and suggestions

The best place to ask questions, or suggest improvements about these components is the [GitHub discussion board for this repository](https://github.com/TotallyInformation/web-components/discussions).

## Contributing

If you would like to contribute to this node, you can contact [Totally Information via GitHub](https://github.com/TotallyInformation) or raise a request in the [GitHub issues log](https://github.com/TotallyInformation/web-components/issues).

<!-- Please refer to the [contributing guidelines](https://github.com/TotallyInformation/node-red-contrib-uibuilder/blob/master/.github/CONTRIBUTING.md) for more information. -->

## Developers/Contributors

- [Julian Knight](https://github.com/TotallyInformation) - the designer and main author.

   <a href="https://stackexchange.com/users/1375993/julian-knight"><img src="https://stackexchange.com/users/flair/1375993.png" width="208" height="58" alt="profile for Julian Knight on Stack Exchange, a network of free, community-driven Q&amp;A sites" title="profile for Julian Knight on Stack Exchange, a network of free, community-driven Q&amp;A sites" /></a>

   Please also check out my blog, [Much Ado About IT](https://it.knightnet.org.uk), it has information about all sorts of topics, mainly IT related, including Node-RED.
